#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	[PluginInfo(Name = "Framedelayed", Category = "Bug")]
	public class FramedelayedNode : IPluginEvaluate
	{
		[Input("Input", DefaultValue = 1.0)]
		public ISpread<Matrix4x4> FInput;

		[Output("Output", AllowFeedback = true)]
		public ISpread<Matrix4x4> FOutput;
		
		Spread<Matrix4x4> FBuffer = new Spread<Matrix4x4>(0);
		
		public void Evaluate(int spreadMax)
		{
//			FOutput.SliceCount = FBuffer.SliceCount;
//			for (int i=0; i<FBuffer.SliceCount; i++)
//				FOutput[i] = FBuffer[i];
//			
//			FBuffer.SliceCount = FInput.SliceCount;
//			for (int i=0; i<FInput.SliceCount; i++)
//				FBuffer[i] = FInput[i];
		}
	}
	
	[PluginInfo(Name = "PassThrough", Category = "Bug")]
	public class PassThroughNode : IPluginEvaluate
	{
		[Input("In", DefaultValue = 1.0)]
		public ISpread<Matrix4x4> FInput;
		
		[Output("Output")]
		public ISpread<Matrix4x4> FOutput;
		
		public void Evaluate(int spreadMax)
		{
			FOutput.AssignFrom(FInput);
		}
	}
}
